ACM--木头序列--贪心+递减子序列--HDOJ 1051--Wooden Sticks

HDOJ题目地址:传送门

Wooden Sticks

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 17453    Accepted Submission(s): 7121

Problem Description

There is a pile of n wooden sticks. The length and weight of each stick are known in advance. The sticks are to be processed by a woodworking machine in one by one fashion. It needs some time, called setup time, for the machine to prepare processing a stick.
The setup times are associated with cleaning operations and changing tools and shapes in the machine. The setup times of the woodworking machine are given as follows:

(a) The setup time for the first wooden stick is 1 minute.

(b) Right after processing a stick of length l and weight w , the machine will need no setup time for a stick of length l‘ and weight w‘ if l<=l‘ and w<=w‘. Otherwise, it will need 1 minute for setup.

You are to find the minimum setup time to process a given pile of n wooden sticks. For example, if you have five sticks whose pairs of length and weight are (4,9), (5,2), (2,1), (3,5), and (1,4), then the minimum setup time should be 2 minutes since there is
a sequence of pairs (1,4), (3,5), (4,9), (2,1), (5,2).

Input

The input consists of T test cases. The number of test cases (T) is given in the first line of the input file. Each test case consists of two lines: The first line has an integer n , 1<=n<=5000, that represents the number of wooden sticks in the test case,
and the second line contains n 2 positive integers l1, w1, l2, w2, ..., ln, wn, each of magnitude at most 10000 , where li and wi are the length and weight of the i th wooden stick, respectively. The 2n integers are delimited by one or more spaces.

Output

The output should contain the minimum setup time in minutes, one per line.

Sample Input

3
5
4 9 5 2 2 1 3 5 1 4
3
2 2 1 1 2 2
3
1 3 2 2 3 1

Sample Output

2
1
3

题意:一个机器生产木头,最开始要一分钟,如果下一个木头比上一个木头短和轻,就需要一分钟的时间调试机器,

如果比上一个长和重就不需要时间调试,求最后的最短时间。

解题:

贪心+递减子序列(严格来说是非递增子序列)。按长度从大到小排序,长度相同,按重量从大到小排序。多次寻找递减子序列,即每次都把这一个序列的木头处理掉,即启动时间+1,并把被处理掉的木头做上标记。用一个变量记录被处理掉木头的个数,多次寻找子序列,处理掉木头,当该变量的个数等于木头总数时,退出循环。

比如第一个测试数据

4 9 5 2 2 1 3 5 14

排序后,为了方便看,我们竖着写。排序后:

l   w

5  2

4  9

3  5

2  1

1  4

有两个递减子序列:

5  2      2  1

4  9      3   5    1   4

#include<iostream>
#include<stdio.h>
#include<memory.h>
#include<algorithm>
using namespace std;
struct Node{
   int length,weight;
   int ok;//用来标记木头是否被处理过
}result[5010];
/**
   sort排序函数
*/
bool cmp(Node a,Node b){
    if(a.length>b.length){
        return true;
    }else if(a.length==b.length){
       if(a.weight>b.weight)
        return true;
       return false;
    }
    return false;
}
int main(){
   int n,m,i,index;
   cin>>n;
   while(n--){
      cin>>m;
      //录入木头的长度和重量
      for(i=0;i<m;i++){
           cin>>result[i].length>>result[i].weight;
           result[i].ok=0;
      }
       //排序
       sort(result,result+m,cmp);
       int sum=0;int index=0;//已经被处理的木头的个数
       Node temp;
        while(1){
            if(index==m)//当所有的木头都被处理时,结束循环
                break;
            //每次启动的时候都要寻找最长最终的木头
            for(int i=0;i<m;i++){
                if(!result[i].ok){
                        temp=result[i];
                         break;//别忘了这一句
                    }
            }
            for(int i=0;i<m;i++){
                //前提是该木头没有被处理,所以必须加上!wood[i].ok
                if(!result[i].ok&&result[i].length<=temp.length&&result[i].weight<=temp.weight){
                    result[i].ok=1;//该木头被处理
                    index++;
                    temp=result[i];//及时更换长度最长,重量最重的那根木头,及递减子序列的当前元素的下一个元素。
                }
            }
            sum++;//一次启动处理结束。
        }
        printf("%d\n",sum);
   }
}

参考博客:传送门

时间: 2024-08-10 03:06:39

ACM--木头序列--贪心+递减子序列--HDOJ 1051--Wooden Sticks的相关文章

HDOJ 1051. Wooden Sticks

HDOJ 1051. Wooden Sticks 题目 There is a pile of n wooden sticks. The length and weight of each stick are known in advance. The sticks are to be processed by a woodworking machine in one by one fashion. It needs some time, called setup time, for the ma

HDOJ 1051. Wooden Sticks 贪心 结构体排序

Wooden Sticks Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 15564    Accepted Submission(s): 6405 Problem Description There is a pile of n wooden sticks. The length and weight of each stick a

【贪心专题】HDU 1051 Wooden Sticks (切割木棍)

链接:click here~~ 题目大意: 给n根木棍的长度和重量.根据要求求出制作木棍的最短时间.建立第一个木棍需要1分钟,若是接着要制作的木棍重量和长度都比此木棍长就不需要建立的时间,若是没有,则再需要建立时间.求时间最小为多少. [解题思路] 对木棍的长度和重量进行排序,以长度为首要考虑(也可以先考虑重量). 于是,我们对排序后的数组进行多次扫描,在一次建立时间内完成的进行标记,直到木棍全部标记(设置一个外部变量来计数已扫描的元素的数量) 举个别人的例子,加深理解 5 4 9  5 2 2

HDU 1051 Wooden Sticks (贪心)

Wooden Sticks Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 11249    Accepted Submission(s): 4629 Problem Description There is a pile of n wooden sticks. The length and weight of each stick a

HDU 1051 Wooden Sticks【贪心+排序】

/* 中文题目 木头 中文翻译-大意 加工第一个木头要调试机器,所以要一分钟,后面的木头在长度和重量上都要大于等于前一个木头,才不要调试机器,否则要调试机器,再花费一分钟 解题思路:先将木头的长度按升序排序,后面质量发生冲突的地方就要在之后重新安排一下 解题人:lingnichong 解题时间:2014-10-25 16:33:10 解题体会:一个括号的丢失,就导致错了一大片 */ Wooden Sticks Time Limit: 2000/1000 MS (Java/Others)    M

HDU 1051 Wooden Sticks 贪心||DP

Wooden Sticks Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 22000    Accepted Submission(s): 8851 Problem Description There is a pile of n wooden sticks. The length and weight of each stick ar

1051 Wooden Sticks(贪心-3)

Problem Description There is a pile of n wooden sticks. The length and weight of each stick are known in advance. The sticks are to be processed by a woodworking machine in one by one fashion. It needs some time, called setup time, for the machine to

杭电 1051 Wooden Sticks

Description There is a pile of n wooden sticks. The length and weight of each stick are known in advance. The sticks are to be processed by a woodworking machine in one by one fashion. It needs some time, called setup time, for the machine to prepare

HDU 1051 Wooden Sticks 贪心题解

本题一看就知道是最长不减序列了,一想就以为是使用dp解决了.不过那是个错误的思路. 我就动了半天没动出来.然后看了看别人是可以使用dp的,不过那个比较难证明其正确性,而其速度也不快.故此并不是很好的解决方法. 所以我就直接硬算,硬模拟选择出非减子序列,选完就出答案了. 思路: 1 按照长度排序 2 按照不减原则选择重量,选一个,消灭一个. 最后消灭完了,就处理完毕,答案就自然出来了. 原来是一道披着dp的外套的模拟题啊!一道伪装成难题的简单题. 代码也可以写的非常简洁: #include <st